/*
 * updateall - update the /usr/catman files
 *
 * All of the unformatted manual pages are checked against the copies
 * in the /usr/catman directory. If the unformatted copy is newer, a
 * new formatted and packed copy is placed in /usr/catman.
 *
 * AUTHOR
 *	Edward C. Bennett, edward@ukecc.UUCP
 *
 * Copyright 1985 by Edward C. Bennett
 *
 * Permission is given to alter this code as needed to adapt it to forign
 * systems provided that this header is included and that the original
 * author's name is preserved.
 */

/* This QDOS version by Roberto Porro 1999 */

#include <stdio.h>
#include <fcntl.h>
#include <qdos.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <string.h>

char _prog_name[] = "updateall";
char *_endmsg = NULL; /* suppress Press a key to exit */

char	*mandirs[] = {
	"win1_usr_man_u_man_man1",
	"win1_usr_man_p_man_man2",
	"win1_usr_man_p_man_man3",
	"win1_usr_man_u_man_man6",
	"win1_usr_man_p_man_man4",
	"win1_usr_man_p_man_man5",
	"win1_usr_man_a_man_man1",
	"win1_usr_man_a_man_man7",
	"win1_usr_man_a_man_man8",
};

#define	NUMDIRS		sizeof(mandirs)/sizeof(char *)

main()
{
	char	manbuf[BUFSIZ], cmd[BUFSIZ], catbuf[BUFSIZ], catbufz[BUFSIZ];
	int	status;
	void	exit();
	struct	stat	manstat, catstat;
	int	fd, i;
	long	lseek();
	qdirect_t	manent;

	/*chdir("/usr/man");*/

	for (i = 0; i < NUMDIRS; i++) {

		if ((fd = open(mandirs[i], O_RDONLY)) == -1)
			continue;

		/*lseek(fd, 2*sizeof(manent), 0);*/
		
		while (read(fd, &manent, sizeof(manent)) == sizeof(manent)) {
			if (manent.d_length == 0)
				continue;

			sprintf(manbuf, "%s", (manent.d_name)+7);
			strcpy(catbuf, "win1_usr_catman");
			strcat(catbuf, manbuf);
			strcpy(catbufz, catbuf);
			strcat(catbufz, "_z"); /* the pack extension
						  remove if not required
						  by your pack version */
			
			stat(manbuf, &manstat);
			if (stat(catbufz, &catstat) == -1)
				catstat.st_mtime = -1;
			if (catstat.st_mtime < manstat.st_mtime) {
				unlink(catbufz);
				sprintf(cmd, "-man win1_%s > %s", manent.d_name, catbuf);
				execlp( "nroff", -1L, "nroff", cmd, NULL);
#ifdef USEPACK
				sprintf(cmd, "e %s %s", catbuf, catbufz);
				execlp( "pack", -1L, "pack", cmd, NULL );
#endif
			}
		}
	}
}

